/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2003
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 *
 * $Id: acconfig.h,v 1.40 2003/06/13 15:01:07 erik Rel $
 ********************************************************************************************************************************/

#ifndef _XZX_CONFIG_H
#define _XZX_CONFIG_H

/*********************************************************************************************************************************
 * General configuration
 ********************************************************************************************************************************/

/* The file z80.c contains the code for the emulation of the Z80, which itself is a huge switch statement. With optimizations
   turned on, CC needs a huge amount of memory in order to compile/optimize this code. Undefine this if you run out of swap
   space. */
#define HAVE_ENOUGH_SWAP

/*********************************************************************************************************************************
 * Configuration valid for both evaluation and full version
 ********************************************************************************************************************************/

/* Define this for Pentagon emulation support. */
#undef XZX_PENTAGON

/* Define this for Scorpion emulation support. */
#undef XZX_SCORPION

/* Define this for Interface I and Microdrive support. */
#undef XZX_IF1

/* How many microrives are there (1-8)? */
#define IF1_DRIVES		2

/* Define this for Multiface 128/3 support.  You need an image of the Multiface ROM. The built-in debugger is a good replacement
   for the Multiface, so you should not have any reason to turn the emulation on. */
#undef XZX_MF

/* Define this for Kempston mouse support. At the moment only used from the Pentagon and Scorpion emulation. */
#undef XZX_KMOUSE

/* Sound support (automatically adjusted by 'configure'). */
#undef SOUND_NATIVE

/* Joystick support (automatically adjusted by 'configure').
   You need Linux/FreeBSD with a joystick driver. */
#undef JOY


/*********************************************************************************************************************************
 * Configuration valid for the evaluation version only
 ********************************************************************************************************************************/


/*********************************************************************************************************************************
 * Configuration valid for the full version only
 ********************************************************************************************************************************/

/* Define this for Scorpion emulation support. */
#undef XZX_DIDAKTIK

/* Define this for Beta 128 emulation support. */
#undef XZX_TRDOS

/* Define this for +D emulation support. */
#undef XZX_PLUSD

/* Printer support.
   Choose the printer support type you want. */

/* Emulate ZX printer */
#undef ZX_PRINTER

/* Emulate Interface I printer */
#undef IF1_PRINTER

/* Emulate Spectrum 128/+3 serial printer */
#undef SP128_PRINTER

/* Emulate +3 centronics printer */
#undef PLUS3_PRINTER

/* Emulate Scorpion centronics printer */
#undef SCORPION_PRINTER

/* Emulate +D centronics printer */
#undef PLUSD_PRINTER


/*********************************************************************************************************************************
 * Do not change anything below this line
 ********************************************************************************************************************************/

@TOP@
@BOTTOM@

#include "config2.h"

#endif /* ! _XZX_CONFIG_H */

/* EOF **************************************************************************************************************************/
