/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2003
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: sound_esound.c,v 4.9 2003/03/26 18:35:06 erik Rel $";
#endif
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <assert.h>
#include <esd.h>
#include "monitor/debug.h"
#include "ui/resource.h"
#include "util.h"
#include "main.h"
#include "sound/sound.h"
#ifdef DEBUG
#define DEB(x)	{ if ((CFGGET(debug) & D_SOUND) != 0) { x } }
#else
#define DEB(x)
#endif
static int audioFd=-1;int OsdOpenAudioDevice(const char*device,int*sample,int*stereo){esd_server_info_t*info=(esd_server_info_t*)0;esd_format_t esd_format;int fd;
#ifdef SOUND_NONBLOCKING
int flags;
#endif
if((fd=esd_open_sound(device))<0){Msg(M_PERR,"couldn't connect to audio server");return-2;}if((info=esd_get_server_info(fd))==(esd_server_info_t*)0){Msg(M_PERR,"couldn't get server info");(void)esd_close(fd);return-1;}DEB(Msg(M_DEBUG,"SND: server           %s",device!=(char*)0?device:"/tmp/.esd");Msg(M_DEBUG,"SND: sample bits      %u",info->format&ESD_BITS16?16:8);Msg(M_DEBUG,"SND: sample rate      %u",info->rate);Msg(M_DEBUG,"SND: channels         %u",info->format&ESD_STEREO?2:1););esd_format=ESD_STREAM|ESD_PLAY|ESD_BITS8|(info->format&ESD_MASK_CHAN);*sample=info->rate;*stereo=(info->format&ESD_STEREO)==0;esd_free_server_info(info);(void)esd_close(fd);if((audioFd=esd_play_stream(esd_format,*sample,device,Version))<0){Msg(M_PERR,"couldn't connect to audio server");return-2;}
#ifdef SOUND_NONBLOCKING
flags=fcntl(audioFd,F_GETFL);if(flags<0||fcntl(audioFd,F_SETFL,flags|O_NONBLOCK)<0){Msg(M_PERR,"couldn't set nonblocking mode");goto error;}
#endif
return 0;error:(void)close(audioFd);audioFd=-1;return-1;}void OsdCloseAudioDevice(void){assert(audioFd!=-1);(void)close(audioFd);audioFd=-1;}int OsdDrainAudioDevice(void){return 0;}
#ifdef SOUND_NONBLOCKING
int OsdGetAudioFreespace(void){return(SoundDataP->sampleRate<<SoundDataP->stereo);}
#endif
int OsdPlayAudioBuffer(unsigned char*buf,int len){int written,remain;for(written=0,remain=len;remain>0;buf+=written,remain-=written){do{written=(int)write(audioFd,buf,(size_t)remain);}while(written<0&&errno==EINTR);if(written<0){break;}}if(written<0&&errno!=EAGAIN){Msg(M_PERR,"couldn't write to audio device");return written;}return len-remain;}
