/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2003
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: sound_nas.c,v 4.7 2003/05/02 20:19:12 erik Rel $";
#endif
#include <sys/types.h>
#include <assert.h>
#include <audio/audiolib.h>
#include "monitor/debug.h"
#include "ui/resource.h"
#include "util.h"
#include "sound/sound.h"
#ifdef DEBUG
#define DEB(x)	{ if ((CFGGET(debug) & D_SOUND) != 0) { x } }
#else
#define DEB(x)
#endif
static AuBool nasIoError(AuServer*);static AuServer*nasServer=(AuServer*)0;static AuDeviceID nasDevice=AuNone;static AuFlowID nasChannel;static int nasQueueSize;int OsdOpenAudioDevice(const char*device,int*sample,int*stereo){AuElement elements[2];AuElementAction actions[1];AuStatus status;char msg[80];int tracks,i;if((nasServer=AuOpenServer(device,0,(char*)0,0,(char*)0,(char**)0))==(AuServer*)0){Msg(M_ERR,"couldn't connect to audio server");return-2;}for(tracks=2;tracks;tracks--){for(i=0;i<AuServerNumDevices(nasServer);i++){if((AuDeviceKind(AuServerDevice(nasServer,i))==AuComponentKindPhysicalOutput)&&AuDeviceNumTracks(AuServerDevice(nasServer,i))==tracks){nasDevice=AuDeviceIdentifier(AuServerDevice(nasServer,i));goto found;}}}found:if(nasDevice==AuNone){Msg(M_ERR,"couldn't find output device");AuCloseServer(nasServer);nasServer=(AuServer*)0;return-2;}if((nasChannel=AuCreateFlow(nasServer,(AuStatus*)0))==(AuFlowID)0){Msg(M_ERR,"couldn't create flow");goto error;}DEB(Msg(M_DEBUG,"SND: server           %s",AuServerString(nasServer));Msg(M_DEBUG,"SND: min sample rate  %u",AuServerMinSampleRate(nasServer));Msg(M_DEBUG,"SND: max sample rate  %u",AuServerMaxSampleRate(nasServer));Msg(M_DEBUG,"SND: channels         %u",tracks););if(*sample>AuServerMaxSampleRate(nasServer)){*sample=AuServerMaxSampleRate(nasServer);}else if(*sample<AuServerMinSampleRate(nasServer)){*sample=AuServerMinSampleRate(nasServer);}*stereo=tracks==2;nasQueueSize=*sample<<*stereo;(void)AuSetIOErrorHandler(nasServer,nasIoError);AuMakeChangeStateAction(&actions[0],AuStateStop,AuStateStart,AuReasonEOF,nasChannel,AuElementAll,AuStateStart);AuMakeElementImportClient(&elements[0],(unsigned short)*sample,AuFormatLinearUnsigned8,(unsigned char)tracks,AuTrue,(AuUint32)nasQueueSize,(AuUint32)0,1,actions);AuMakeElementExportDevice(&elements[1],0,nasDevice,(unsigned short)*sample,AuUnlimitedSamples,0,(AuElementAction*)0);AuSetElements(nasServer,nasChannel,AuTrue,2,elements,&status);if(status!=AuSuccess){AuGetErrorText(nasServer,status,msg,sizeof(msg));Msg(M_ERR,"couldn't config flow: %s",msg);goto error;}AuStartFlow(nasServer,nasChannel,&status);if(status!=AuSuccess){AuGetErrorText(nasServer,status,msg,sizeof(msg));Msg(M_ERR,"couldn't start flow: %s",msg);goto error;}return 0;error:AuCloseServer(nasServer);nasServer=(AuServer*)0;return-1;}void OsdCloseAudioDevice(void){assert(nasServer!=(AuServer*)0);AuStopFlow(nasServer,nasChannel,(AuStatus*)0);AuCloseServer(nasServer);nasServer=(AuServer*)0;}int OsdDrainAudioDevice(void){AuFlush(nasServer);return 0;}
#ifdef SOUND_NONBLOCKING
int OsdGetAudioFreespace(void){return nasQueueSize;}
#endif
int OsdPlayAudioBuffer(unsigned char*buf,int len){AuWriteElement(nasServer,nasChannel,0,(AuUint32)len,(AuPointer)buf,AuFalse,(AuStatus*)0);return len;}static AuBool nasIoError(AuServer*server){USED(server);Msg(M_FATAL,"non recoverable error in NAS audio system");return AuTrue;}
